package com.me.brickbuster.layout;

import com.badlogic.gdx.files.FileHandle;
import com.badlogic.gdx.utils.Array;
import com.badlogic.gdx.utils.Json;
import com.me.brickbuster.entity.Brick;
import com.me.brickbuster.state.PlayState;

public class FileLayout implements BrickLayout {

	private static final Json JSON = new Json();

	private PlayState state;
	private Array<Brick> bricks;
	private FileHandle file;

	public FileLayout(PlayState state, FileHandle file) {
		this.state = state;
		this.file = file;
	}

	@Override
	public void initialize() {
		bricks = new Array<Brick>();

		LevelJsonTemplate level = JSON.fromJson(LevelJsonTemplate.class, file);
		for (LevelJsonTemplate.BrickJsonTemplate brick : level.bricks) {
			final float x = PlayState.EDGE_PADDING + Brick.BRICK_WIDTH/2 + brick.col * Brick.BRICK_WIDTH;
			final float y = PlayState.EDGE_PADDING + Brick.BRICK_HEIGHT/2 + brick.row * Brick.BRICK_HEIGHT;

			bricks.add(new Brick(state, brick.type, brick.shape, brick.powerUp, x, PlayState.BOARD_HEIGHT - y));
		}
	}

	@Override
	public Array<Brick> getBricks() {
		return bricks;
	}


}
